//---------------------------------------------------------------------------
#ifndef CABArchiverH
#define CABArchiverH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include "Cabinet.hpp"
#pragma link "cab.lib"
/*
      TCABItem, TCABContents, TCABArchiver is copyright to Couturiaux Martial
      mcouturiaux@freegates.be
      Please, the only think I ask you. If you correct or change the
      original source, please send me EMAil. Thank..
*/
//---------------------------------------------------------------------------
enum TCompression {None,MsZip,Lzx15,Lzx16,Lzx17,Lzx18,Lzx19,Lzx20,Lzx21};
enum TMode {cmExtractAll,cmGetContents,cmGetSizeOfList,cmExtractFile,cmCompress};
enum TStat {cmMessage,cmProgressFirst,cmProgress,cmStatus,cmSecondFirst,cmSecond,cmTime};
enum TDisk {InOctect,InKilobyte,InMegabyte};
typedef void __fastcall (__closure *TCABMessage)(System::TObject* sender, int position, int total,AnsiString message,TStat mode,AnsiString Lapse);
class TCABArchiver;
//---------------------------------------------------------------------------
//
//          TCABItem
//
//---------------------------------------------------------------------------
class TCABItem
{
protected:
     AnsiString FFileName;
public:
     AnsiString FilePath;
     AnsiString FileFull;
     AnsiString UpFileName;
     AnsiString UpFilePath;
     AnsiString UpFileFull;
     AnsiString RecordFileName;
     AnsiString ReturnFileName;
     AnsiString DoFileName;
     AnsiString SearchFile;
     bool Extract,IsSelected;
     int Size;
     TCompression FCompression;
     TCompressionParameters FComp;
public:
     __fastcall TCABItem();
public:
     void SetFileName(AnsiString file);
     void SetCompression(TCompression comp);
public:
     __property AnsiString FileName = {write=SetFileName,read=FFileName};
     __property TCompression Comp = {write=SetCompression,read=FCompression};

};
//---------------------------------------------------------------------------
//
//          TCABContents
//
//---------------------------------------------------------------------------
class TCABContents:public TStringList
{
public:
     bool Extract;
     TCABArchiver* AOwner;
public:
     __fastcall TCABContents(TCABArchiver* Owner);
     TCABItem* AddItem();
     TCABItem* GetItem(int index);
     double GetTotalSize();
     int Search(AnsiString name);
};
//---------------------------------------------------------------------------
//
//          TCABArchiver
//
//---------------------------------------------------------------------------

class PACKAGE TCABArchiver : public TComponent
{
private:
        TCabinetWriter* CabinetWriter1;
        TCabinetReader* CabinetReader1;
        TStreamCabinetFileHandler* CabinetStream1;
        TAddFileOptions AddOptions;
        double Total;
        int Pos,Sizer,Type;
        int CurrentFile1,CurrentFile2;
        long Beta1,Beta2;
        AnsiString FExtractDir,CurrentFile,NextFileName;
        TMode Mode;
        DWORD Begin,Stop;
        TCompression FCompression;
        TDisk FTypeCut;
        bool FMultiDisk,Try;
        int FSize,Sesame;
protected:
        AnsiString FFileName;
	void __fastcall CABMessage(int position, int total,AnsiString message,TStat mode,AnsiString Lapse="");
	TCABMessage FOnCABMessage;
        void Raise(int Error);
        void __fastcall CabinetReader1CopyFile(TObject *Sender,const AnsiString FileName, int UncompressedSize, short Date,
               short Time, short Attribs, TFileCopyAction &Action,int &DestFileHandle);
        void __fastcall CabinetWriter1FileStatus(TObject *Sender,int CompressedSize,int UncompressedSize,int &ResultCode);
        void __fastcall CabinetWriter1FilePlacedEvent(TObject* Sender,TCCAB &CabParameters,const AnsiString FileName,int FileLength,bool Continuation,bool &AbortProcessing);
        void __fastcall CabinetWriter1GetNextCabinet(TObject* Sender,TCCAB &CabParameters,AnsiString &NewCabFileName,int PreviousCabEstimatedSize,bool &AbortProcessing);
        void  __fastcall GetMultiDiskSize();
        void __fastcall CabinetReader1GetNextCabinet(TObject* Sender,const AnsiString NextCabinetName,const AnsiString NextCabinetDisk,AnsiString &CabinetPath,TFDIERROR ErrorIndication, bool &Abort);
protected:
        void __fastcall SetExtract(bool extract);
        bool __fastcall GetExtract();
        TCABItem* GetCabItem(int index);
        void Start();
        void End();
        AnsiString AnsiTime();
public:
        TCABContents* Contents;
public:
        __fastcall TCABArchiver(TComponent* Owner);
        __fastcall ~TCABArchiver();
        bool __fastcall Compress();
        bool ExtractAll();
        bool ExtractFile();
        bool ExtractSpan();
        double GetContents();
        __property TCABItem* Item[int index] = {read=GetCabItem};
__published:
        __property AnsiString FileName = {read=FFileName,write=FFileName};
       	__property TCABMessage OnCABMessage = {read=FOnCABMessage, write=FOnCABMessage};
        __property bool FileDirExtraction = {read=GetExtract,write=SetExtract};
        __property AnsiString ExtractDir = {read=FExtractDir,write=FExtractDir};
        __property TCompression Compression = {read=FCompression,write=FCompression};
        __property bool MultiDisk = {read=FMultiDisk,write=FMultiDisk,default=false};
        __property TDisk TypeCut = {read=FTypeCut,write=FTypeCut,default=TDisk(InMegabyte)};
        __property int Size = {read=FSize,write=FSize,default=0};
};
//---------------------------------------------------------------------------
#endif
