// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Cabinet.pas' rev: 4.00

#ifndef CabinetHPP
#define CabinetHPP

#pragma delphiheader begin
#pragma option push -w-
#include "Fdi.hpp"	// Pascal unit
#include "Fci.hpp"	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Cabinet
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TAddFileOption { afoExecuteOnExtract };
#pragma option pop

typedef Set<TAddFileOption, afoExecuteOnExtract, afoExecuteOnExtract>  TAddFileOptions;

#pragma option push -b-
enum TFileType { ftCabinet, ftSource, ftDestination };
#pragma option pop

#pragma option push -b-
enum TCompressionType { ctNone, ctMsZip, ctQuantum, ctLzx };
#pragma option pop

#pragma pack(push, 1)
struct TCompressionParameters
{
	TCompressionType Compression;
	Shortint LzxLevel;
	Shortint QuantumLevel;
	Shortint QuantumMemory;
} ;
#pragma pack(pop)

#pragma option push -b-
enum TCpuType { cptAuto, cpt80286, cpt80386 };
#pragma option pop

#pragma option push -b-
enum TFileCopyAction { fcaAbort, fcaSkip, fcaCopy, fcaDefaultCopy };
#pragma option pop

typedef void __fastcall (__closure *TFileStatusEvent)(System::TObject* Sender, int CompressedSize, int 
	UncompressedSize, int &ResultCode);

typedef void __fastcall (__closure *TFolderStatusEvent)(System::TObject* Sender, int SizeCopied, int 
	TotalSize, int &ResultCode);

typedef void __fastcall (__closure *TCabinetStatusEvent)(System::TObject* Sender, int PreEstimatedSize
	, int ActualSize, int &WantedSize);

typedef void __fastcall (__closure *TGetNextCabinetEvent)(System::TObject* Sender, Fci::TCCAB &CabParameters
	, AnsiString &NewCabFileName, int PreviousCabEstimatedSize, bool &AbortCreation);

typedef void __fastcall (__closure *TFilePlacedEvent)(System::TObject* Sender, Fci::TCCAB &CabParameters
	, const AnsiString FileName, int FileLength, bool Continuation, bool &AbortProcessing);

typedef void __fastcall (__closure *TGetTempFileEvent)(System::TObject* Sender, AnsiString &TempFileName
	, bool &Success);

typedef void __fastcall (__closure *TGetOpenInfoEvent)(System::TObject* Sender, const AnsiString FileName
	, short &Date, short &Time, short &Attributes, int &FileHandle, int &ResultCode);

typedef void __fastcall (__closure *TCabinetInfoEvent)(System::TObject* Sender, const AnsiString CabinetName
	, const AnsiString CabinetDisk, const AnsiString CabinetPath, int SetId, int CabinetNumber, bool &Abort
	);

typedef void __fastcall (__closure *TPartialFileEvent)(System::TObject* Sender, const AnsiString FileName
	, const AnsiString FirstCabinetName, const AnsiString FirstCabinetDisk, bool &Abort);

typedef void __fastcall (__closure *TCopyFileEvent)(System::TObject* Sender, const AnsiString FileName
	, int UncompressedSize, short Date, short Time, short Attribs, TFileCopyAction &Action, int &DestFileHandle
	);

typedef void __fastcall (__closure *TCloseCopiedFileEvent)(System::TObject* Sender, const AnsiString 
	FileName, int FileHandle, short Date, short Time, short Attribs, int FolderIndex, bool Execute, bool 
	&Abort);

typedef void __fastcall (__closure *TNextCabinetEvent)(System::TObject* Sender, const AnsiString NextCabinetName
	, const AnsiString NextCabinetDisk, AnsiString &CabinetPath, Fdi::TFDIERROR ErrorIndication, bool &
	Abort);

class DELPHICLASS TCabinetFileHandler;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TCabinetFileHandler : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
public:
	virtual int __fastcall Open(const AnsiString FileName, int OpenFlag, int OpenMode, int &Error, TFileType 
		FileType) = 0 ;
	virtual int __fastcall Read(int FileHandle, void *Buffer, int Count, int &Error) = 0 ;
	virtual int __fastcall Write(int FileHandle, void *Buffer, int Count, int &Error) = 0 ;
	virtual int __fastcall Close(int FileHandle, int &Error) = 0 ;
	virtual int __fastcall Seek(int FileHandle, int Distance, int SeekType, int &Error) = 0 ;
	virtual int __fastcall Delete(const AnsiString FileName, int &Error) = 0 ;
public:
	#pragma option push -w-inl
	/* TComponent.Create */ inline __fastcall virtual TCabinetFileHandler(Classes::TComponent* AOwner) : 
		Classes::TComponent(AOwner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TComponent.Destroy */ inline __fastcall virtual ~TCabinetFileHandler(void) { }
	#pragma option pop
	
};

#pragma pack(pop)

class DELPHICLASS TStreamCabinetFileHandler;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TStreamCabinetFileHandler : public TCabinetFileHandler 
{
	typedef TCabinetFileHandler inherited;
	
protected:
	Classes::TList* FStreams;
	Classes::TStream* __fastcall FindStream(int Handle);
	
public:
	__fastcall virtual TStreamCabinetFileHandler(Classes::TComponent* AOwner);
	__fastcall virtual ~TStreamCabinetFileHandler(void);
	virtual int __fastcall Open(const AnsiString FileName, int OpenFlag, int OpenMode, int &Error, TFileType 
		FileType);
	virtual int __fastcall Read(int FileHandle, void *Buffer, int Count, int &Error);
	virtual int __fastcall Write(int FileHandle, void *Buffer, int Count, int &Error);
	virtual int __fastcall Close(int FileHandle, int &Error);
	virtual int __fastcall Seek(int FileHandle, int Distance, int SeekType, int &Error);
	virtual int __fastcall Delete(const AnsiString FileName, int &Error);
};

#pragma pack(pop)

class DELPHICLASS TCabinetInterface;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TCabinetInterface : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
protected:
	Fdi::TERF FErrorBuffer;
	TCabinetFileHandler* FFileHandler;
	void __fastcall CabCheck(bool Result);
	
public:
	__property TCabinetFileHandler* FileHandler = {read=FFileHandler, write=FFileHandler};
public:
	#pragma option push -w-inl
	/* TComponent.Create */ inline __fastcall virtual TCabinetInterface(Classes::TComponent* AOwner) : 
		Classes::TComponent(AOwner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TComponent.Destroy */ inline __fastcall virtual ~TCabinetInterface(void) { }
	#pragma option pop
	
};

#pragma pack(pop)

class DELPHICLASS TCabinetWriter;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TCabinetWriter : public TCabinetInterface 
{
	typedef TCabinetInterface inherited;
	
protected:
	void *FContext;
	bool FFailOnIncompressible;
	bool FFileSupport;
	TFileStatusEvent FOnFileStatus;
	TFolderStatusEvent FOnFolderStatus;
	TCabinetStatusEvent FOnCabinetStatus;
	TGetNextCabinetEvent FOnGetNextCabinet;
	TFilePlacedEvent FOnFilePlacedEvent;
	TGetOpenInfoEvent FOnGetOpenInfo;
	TGetTempFileEvent FOnGetTempFile;
	virtual void __fastcall DoFileStatus(int CompressedSize, int UncompressedSize, int &ResultCode);
	virtual void __fastcall DoFolderStatus(int SizeCopied, int TotalSize, int &ResultCode);
	virtual void __fastcall DoCabinetStatus(int PreEstimatedSize, int ActualSize, int &WantedSize);
	virtual void __fastcall DoGetNextCabinet(Fci::TCCAB &CabParameters, AnsiString &NewCabFileName, int 
		PreviousCabEstimatedSize, bool &AbortCreation);
	virtual void __fastcall DoFilePlaced(Fci::TCCAB &CabParameters, const AnsiString FileName, int FileLength
		, bool Continuation, bool &AbortProcessing);
	virtual void __fastcall DoGetTempFile(AnsiString &TempFileName, bool &Success);
	virtual void __fastcall DoGetOpenInfo(const AnsiString FileName, short &Date, short &Time, short &Attributes
		, int &FileHandle, int &ResultCode);
	
public:
	__fastcall virtual TCabinetWriter(Classes::TComponent* AOwner);
	__fastcall virtual ~TCabinetWriter(void);
	void __fastcall Open(const AnsiString CabinetFileName, const AnsiString DiskName, int MaximumCabSize
		, int FolderThreshold, int SetId);
	void __fastcall Close(void);
	void __fastcall AddFile(const AnsiString SourceFileName, const AnsiString DestFileName, const TAddFileOptions 
		Options, const TCompressionParameters Compression);
	void __fastcall FlushCabinet(bool GetNextCabinet);
	void __fastcall FlushFolder(void);
	__property void * Context = {read=FContext};
	
__published:
	__property bool FailOnIncompressible = {read=FFailOnIncompressible, write=FFailOnIncompressible, default=1
		};
	__property bool FileSupport = {read=FFileSupport, write=FFileSupport, default=1};
	__property TFileStatusEvent OnFileStatus = {read=FOnFileStatus, write=FOnFileStatus};
	__property TFolderStatusEvent OnFolderStatus = {read=FOnFolderStatus, write=FOnFolderStatus};
	__property TCabinetStatusEvent OnCabinetStatus = {read=FOnCabinetStatus, write=FOnCabinetStatus};
	__property TGetNextCabinetEvent OnGetNextCabinet = {read=FOnGetNextCabinet, write=FOnGetNextCabinet
		};
	__property TFilePlacedEvent OnFilePlacedEvent = {read=FOnFilePlacedEvent, write=FOnFilePlacedEvent}
		;
	__property TGetOpenInfoEvent OnGetOpenInfo = {read=FOnGetOpenInfo, write=FOnGetOpenInfo};
	__property TGetTempFileEvent OnGetTempFile = {read=FOnGetTempFile, write=FOnGetTempFile};
	__property FileHandler ;
};

#pragma pack(pop)

class DELPHICLASS TCabinetReader;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TCabinetReader : public TCabinetInterface 
{
	typedef TCabinetInterface inherited;
	
protected:
	void *FContext;
	TCpuType FCpuType;
	AnsiString FDestinationPath;
	TCabinetInfoEvent FOnCabinetInfo;
	TPartialFileEvent FOnPartialFile;
	TCopyFileEvent FOnCopyFile;
	TCloseCopiedFileEvent FOnCloseCopiedFile;
	TNextCabinetEvent FOnNextCabinet;
	bool FFileSupport;
	void __fastcall DestroyContext(void);
	void __fastcall ContextNeeded(void);
	virtual void __fastcall DoCabinetInfo(const AnsiString CabinetName, const AnsiString CabinetDisk, const 
		AnsiString CabinetPath, int SetId, int CabinetNumber, bool &Abort);
	virtual void __fastcall DoPartialFile(const AnsiString FileName, const AnsiString FirstCabinetName, 
		const AnsiString FirstCabinetDisk, bool &Abort);
	virtual void __fastcall DoCopyFile(const AnsiString FileName, int UncompressedSize, short Date, short 
		Time, short Attribs, TFileCopyAction &Action, int &DestFileHandle);
	virtual void __fastcall DoCloseCopiedFile(const AnsiString FileName, int FileHandle, short Date, short 
		Time, short Attribs, int FolderIndex, bool Execute, bool &Abort);
	virtual void __fastcall DoNextCabinet(const AnsiString NextCabinetName, const AnsiString NextCabinetDisk
		, AnsiString &CabinetPath, Fdi::TFDIERROR ErrorIndication, bool &Abort);
	
public:
	__fastcall virtual TCabinetReader(Classes::TComponent* AOwner);
	__fastcall virtual ~TCabinetReader(void);
	bool __fastcall IsCabinet(const AnsiString FileName, Fdi::TFDICABINETINFO &CabInfo);
	void __fastcall ExtractFiles(const AnsiString FileName, const AnsiString DestinationPath, int Flags
		);
	__property void * Context = {read=FContext};
	
__published:
	__property TCpuType CpuType = {read=FCpuType, write=FCpuType, nodefault};
	__property AnsiString DestinationPath = {read=FDestinationPath};
	__property bool FileSupport = {read=FFileSupport, write=FFileSupport, default=1};
	__property TCabinetInfoEvent OnCabinetInfo = {read=FOnCabinetInfo, write=FOnCabinetInfo};
	__property TPartialFileEvent OnPartialFile = {read=FOnPartialFile, write=FOnPartialFile};
	__property TCopyFileEvent OnCopyFile = {read=FOnCopyFile, write=FOnCopyFile};
	__property TCloseCopiedFileEvent OnCloseCopiedFile = {read=FOnCloseCopiedFile, write=FOnCloseCopiedFile
		};
	__property TNextCabinetEvent OnNextCabinet = {read=FOnNextCabinet, write=FOnNextCabinet};
	__property FileHandler ;
};

#pragma pack(pop)

class DELPHICLASS ECabinetError;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION ECabinetError : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	int ErrorCode;
	int ErrorType;
public:
	#pragma option push -w-inl
	/* Exception.Create */ inline __fastcall ECabinetError(const AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall ECabinetError(const AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall ECabinetError(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall ECabinetError(int Ident, const System::TVarRec * Args
		, const int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall ECabinetError(const AnsiString Msg, int AHelpContext) : 
		Sysutils::Exception(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall ECabinetError(const AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall ECabinetError(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall ECabinetError(int Ident, const System::TVarRec * 
		Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext
		) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~ECabinetError(void) { }
	#pragma option pop
	
};

#pragma pack(pop)

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE TCompressionParameters __fastcall MakeNoCompression(void);
extern PACKAGE TCompressionParameters __fastcall MakeMsZipCompression(void);
extern PACKAGE TCompressionParameters __fastcall MakeLzxCompression(int Level);
extern PACKAGE void __fastcall RaiseCabinetError(int ErrorCode, int ErrorType);
extern PACKAGE void __fastcall CheckErf(const Fdi::TERF &Erf);

}	/* namespace Cabinet */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Cabinet;
#endif
#pragma option pop	// -w-

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Cabinet
