//---------------------------------------------------------------------------
#include <vcl.h>
#include <shlobj.h>
#include <WindowsX.h>
#include <shellapi.h>
#include <io.h>
#include <stdio.h>
#include <fcntl.h>
#include "MyString.h"
#include "MyFile.h"
#pragma hdrstop

//---------------------------------------------------------------------------
#pragma package(smart_init)

int handle,Compteur,Total;
int FileHandle1,FileHandle2,Readed;
int Nombre1,Y1;
AnsiString Path,Drive,SubPath;
AnsiString Current1,Current2,Current3;
TSearchRec SearchRec;

AnsiString SlashSep(AnsiString Path,AnsiString S)
{
    return RemoveSlash(Path)+"\\"+RemoveSlash(S);
}
AnsiString RemoveSlash(AnsiString Path)
{
    if (Copy(Path,1,1)=="\\" && Copy(Path,2,1)!="\\") Path = Copy(Path,2,-1);
    if (Copy(Path,Path.Length(),1)=="\\") Path = Copy(Path,1,Path.Length()-1);
    return Path;
}
int  ReadDirectory(AnsiString ParentDirectory,TStringList* DirectoryList)
{
    DirectoryList->Add(MyUpper(ParentDirectory));
    ReadDirectoryNames(ParentDirectory,DirectoryList);
    return DirectoryList->Count;
}
int ReadOnlyDirectory(AnsiString ParentDirectory,TStringList* DirectoryList)
{
    int Status;
    TSearchRec SearchRec;
    Status = FindFirst(SlashSep(ParentDirectory,"*.*"),30,SearchRec);
    try
    {
          while (Status==0)
          {
               if (SearchRec.Attr & faDirectory){
                   if (SearchRec.Name!="." && SearchRec.Name!=".."){
                       DirectoryList->Add(SearchRec.Name);
                   }
               }
               Status = FindNext(SearchRec);
          }
          FindClose(SearchRec);
    }
    catch(...)
    {
          FindClose(SearchRec);
    }
    return DirectoryList->Count;
}
void ReadDirectoryNames(AnsiString ParentDirectory,TStringList* DirectoryList)
{
    int Status;
    TSearchRec SearchRec;
    Status = FindFirst(SlashSep(ParentDirectory,"*.*"),30,SearchRec);
    try
    {
          while (Status==0)
          {
               if (SearchRec.Attr & faDirectory){
                   if (SearchRec.Name!="." && SearchRec.Name!=".."){
                       DirectoryList->Add(SlashSep(ParentDirectory,SearchRec.Name));
                       ReadDirectoryNames(SlashSep(ParentDirectory,SearchRec.Name),DirectoryList);
                   }
               }
               Status = FindNext(SearchRec);
          }
          FindClose(SearchRec);
    }
    catch(...)
    {
          FindClose(SearchRec);
    }
    return;
}
void ReadFilesNames(AnsiString ParentFile,TStringList* FileList,bool Include)
{
    int Status;
    TSearchRec SearchRec;
    Status = FindFirst(SlashSep(ParentFile,"*.*"),30,SearchRec);
    try
    {
          while (Status==0)
          {
               if (SearchRec.Attr & faDirectory){
                   if (SearchRec.Name!="." && SearchRec.Name!=".." &&
                       SearchRec.Name!=NULL){
                       ReadFilesNames(MyFormat("%s%s\\",SlashSep(ParentFile,""),SearchRec.Name),FileList,Include);

                   }
               }
               else{
                   if (SearchRec.Attr | faVolumeID){
                       if (SearchRec.Name!="." && SearchRec.Name!=".." &&
                           SearchRec.Name!=NULL){
                          if (Include){
                              FileList->Add(MyFormat("%s%s",SlashSep(ParentFile,""),SearchRec.Name));
//                              ShowMessage(MyFormat("%s%s",SlashSep(ParentFile,""),SearchRec.Name));
                          }
                          else
                              FileList->Add(SearchRec.Name);
                       }
                   }
               }
               Status = FindNext(SearchRec);
          }
          FindClose(SearchRec);
    }
    catch(...)
    {
          FindClose(SearchRec);
    }
    return;
}
int  ReadFiles(AnsiString ParentFile,TStringList* FileList,bool Include)
{
    ReadFilesNames(ParentFile,FileList,Include);
    return FileList->Count;
}
int  ReadOnlyFiles(AnsiString ParentFile,TStringList* FileList,bool Include)
{
    int Status;
    TSearchRec SearchRec;
    Status = FindFirst(SlashSep(ParentFile,"*.*"),30,SearchRec);
    try
    {
          while (Status==0)
          {
               if (SearchRec.Attr & faDirectory){
               }
               else{
                   if (SearchRec.Attr | faVolumeID){
                       if (SearchRec.Name!="." && SearchRec.Name!=".."){
                          if (Include){
                               FileList->Add(SlashSep(ParentFile,SearchRec.Name));
                          }
                          else{
                               FileList->Add(MyFormat("%s",SearchRec.Name));
                          }
                       }
                   }
               }
               Status = FindNext(SearchRec);
          }
          FindClose(SearchRec);
    }
    catch(...)
    {
          FindClose(SearchRec);
    }
    return FileList->Count;
}
int  FileSize(AnsiString File)
{
    if (FindFirst(File,faAnyFile,SearchRec)==0){
        FindClose(SearchRec);
        return SearchRec.Size;
    }
    else return -1;
}
bool FileExist(AnsiString File)
{
    handle = open(File.c_str(),O_RDONLY);
    close(handle);
    if (handle==-1) return false;
    return true;
}
bool CreateDirectory(AnsiString Directory)
{
    Path = RemoveSlash(Directory);
    Drive = Copy(Path,1,1);
    Compteur = 0;
    for (int i1=1;i1<=Path.Length();i1++){
        if (Copy(Path,i1,1)=="\\"){
            if (Compteur>0){
                SubPath = Copy(Path,1,i1-1);
                CreateDir(SubPath);
            }
            else Compteur++;
        }
    }
    CreateDir(Path);
    return true;
}
bool CompareFile(AnsiString File1,AnsiString File2,TPanel *Panel)
{
    Panel->Caption  = 0;
    Panel->Update();
    if (File1==File2) return true;
    if (!FileExist(File1) ||
        !FileExist(File2)) return false;
    if (FileSize(File1)!=FileSize(File2)) return false;

    char* Buffer1 = new char[2000];
    char* Buffer2 = new char[2000];
    int Long = FileSize(File1);
    int Pos = 0;

    FileHandle1 = FileOpen(File1,fmOpenRead);
    FileHandle2 = FileOpen(File2,fmOpenRead);
    while ( (Readed = FileRead(FileHandle1,Buffer1,1000))>0){
        Pos = Pos + Readed;
        Panel->Caption = PlacePoint(Pos);
        Panel->Update();
        Application->ProcessMessages();
        if (FileRead(FileHandle2,Buffer2,Readed)!=Readed ||
            !CompareMem((void*)Buffer1,(void*)Buffer2,Readed) ){
                FileClose(FileHandle1);
                FileClose(FileHandle2);
                delete[] Buffer1;
                delete[] Buffer2;
                Panel->Caption = "";
                Panel->Update();
                return false;
        }
    }
    FileClose(FileHandle1);
    FileClose(FileHandle2);
    delete[] Buffer1;
    delete[] Buffer2;
    Panel->Caption = "";
    Panel->Update();
    return true;
}
bool IsDirectoryEmpty(AnsiString Directory)
{
    int Status;
    TSearchRec SearchRec;
    Status = FindFirst(SlashSep(Directory,"*.*"),30,SearchRec);
    try{
          while (Status==0)
          {
               if (SearchRec.Name!="." &&
                   SearchRec.Name!=".."){
                       FindClose(SearchRec);
                       return false;
               }
               Status = FindNext(SearchRec);
          }
          FindClose(SearchRec);
          return true;
    }
    catch(...){
          FindClose(SearchRec);
    }
    return true;
}
bool PathCopyFile(AnsiString File1,AnsiString File2)
{
    CreateDirectory(ExtractFileDir(File1));
    CreateDirectory(ExtractFileDir(File2));
    if (FileExist(File2)){
        FileSetAttr(File2,0);
    }
    return CopyFile(File1.c_str(),File2.c_str(),false);
}
bool RemoveFile(AnsiString File)
{
    if (!FileExist(File)) return false;
    FileSetAttr(File,0);
    return DeleteFile(File);
}
bool DeleteDirectory(AnsiString Directory)
{
    TStringList* List1 = new TStringList();
    List1->Clear();

    ReadFiles(Directory,List1,true);
    for (int i1=0;i1<List1->Count;i1++){
        Application->ProcessMessages();
        RemoveFile(List1->Strings[i1]);
    }
    List1->Clear();
    DeleteDirectory2(Directory,List1);
    for (int i1=0;i1<List1->Count;i1++){
         RemoveDir(List1->Strings[i1]);
    }
    try{
         delete List1;
    }
    catch(...){
         delete List1;
    }
    return RemoveDir(Directory);
}
void DeleteDirectory2(AnsiString ParentDirectory,TStringList* List1)
{
    int Status;
    TSearchRec SearchRec;
    Status = FindFirst(SlashSep(ParentDirectory,"*.*"),30,SearchRec);
    try
    {
          while (Status==0)
          {
               if (SearchRec.Attr & faDirectory){
                   if (SearchRec.Name!="." && SearchRec.Name!=".."){
                       DeleteDirectory2(SlashSep(ParentDirectory,SearchRec.Name),List1);
                   }
               }
               Status = FindNext(SearchRec);
          }
          FindClose(SearchRec);
          List1->Add(ParentDirectory);
    }
    catch(...)
    {
          FindClose(SearchRec);
    }
    return;
}
AnsiString BeforeDirectory(AnsiString Directory)
{
    Current1 = RemoveSlash(Directory);
    Current2 = ReturnLine(Current1);
    Nombre1 = Current2.AnsiPos("\\");
    Y1 = 0;
    for (int i1=1;i1<=Current1.Length();i1++){
        if (Copy(Current1,i1,1)=="\\") Y1++;
    }
    if (Y1==0) return "";
//    if (Y1==1) return Directory;
    Current3 = Copy(Current1,1,Current1.Length()-Nombre1);
    return RemoveSlash(Current3);
}
AnsiString TempDirectory()
{
    char Tempof[1010];
    GetTempPath(1000,Tempof);
    return AnsiString(Tempof);
}
AnsiString WindowsDirectory()
{
    char Tempof[1010];
    GetWindowsDirectory(Tempof,1000);
    return AnsiString(Tempof);
}
HICON GetFileIcon(AnsiString file)
{
    HICON Result;
    SHFILEINFO fi;
    memset(&fi, 0, sizeof(fi));

    UINT flags = SHGFI_ICON | SHGFI_ICONLOCATION |SHGFI_SHELLICONSIZE|SHGFI_SMALLICON;
    char Buffer[256];
    Vide(Buffer,255);
    sprintf(Buffer,"%s",file.c_str());

    ::SHGetFileInfo(Buffer,0, &fi, sizeof(fi), flags);
    Result = fi.hIcon;
    return Result;
}
bool DirectoryExist(AnsiString Directory)
{
    int Code = GetFileAttributes(Directory.c_str());
    if (Code!=-1 && Code==FILE_ATTRIBUTE_DIRECTORY && Code!=0) return true;
    return false;
}
void MoveFileInFile(AnsiString FileFrom,AnsiString FileTo)
{
      char Buffer1[2000];
      int FileHandle1 = FileOpen(FileTo,fmOpenReadWrite);
      int Size = FileSize(FileFrom);
      int Nombre = Size / 1000;
      int Reste = Size - Nombre*1000;
      int FileHandle2 = FileOpen(FileFrom,fmOpenRead);
      FileSeek(FileHandle1,0,2);
      for (int i1=1;i1<=Nombre;i1++){
           Vide(Buffer1);
           FileRead(FileHandle2,Buffer1,1000);
           FileWrite(FileHandle1,Buffer1,1000);
      }
      if (Reste>0){
           Vide(Buffer1);
           FileRead(FileHandle2,Buffer1,Reste);
           FileWrite(FileHandle1,Buffer1,Reste);
      }
      FileClose(FileHandle2);
      FileClose(FileHandle1);
}
void MoveFileFrom(AnsiString FileFrom,double Position,AnsiString FileTo)
{
      int Readed;
      char Buffer1[2000];
      int FileHandle1 = FileOpen(FileFrom,fmOpenReadWrite);
      FileSeek(FileHandle1,(int)Position,0);
      int FileHandle2 = FileCreate(FileTo);
      while ( (Readed = FileRead(FileHandle1,Buffer1,1000))>0){
            FileWrite(FileHandle2,Buffer1,Readed);
      }
      FileClose(FileHandle2);
      FileClose(FileHandle1);
}
void MoveFileFromTo(AnsiString FileFrom,double Position,AnsiString FileTo,int Size)
{
      char Buffer1[2000];
      int FileHandle1 = FileOpen(FileFrom,fmOpenReadWrite);
      FileSeek(FileHandle1,(int)Position,0);
      int FileHandle2 = FileCreate(FileTo);
      int Nombre = Size / 1000;
      int Reste = Size - Nombre*1000;
      for (int i1=1;i1<=Nombre;i1++){
          Vide(Buffer1);
          FileRead(FileHandle1,Buffer1,1000);
          FileWrite(FileHandle2,Buffer1,1000);
      }
      if (Reste>0){
          Vide(Buffer1);
          FileRead(FileHandle1,Buffer1,Reste);
          FileWrite(FileHandle2,Buffer1,Reste);
      }
      FileClose(FileHandle2);
      FileClose(FileHandle1);
}
bool CompareFile(AnsiString File1,AnsiString File2)
{
    if (File1==File2) return true;
    if (!FileExist(File1) ||
        !FileExist(File2)) return false;
    if (FileSize(File1)!=FileSize(File2)) return false;

    char* Buffer1 = new char[2000];
    char* Buffer2 = new char[2000];

    FileHandle1 = FileOpen(File1,fmOpenRead);
    FileHandle2 = FileOpen(File2,fmOpenRead);
    while ( (Readed = FileRead(FileHandle1,Buffer1,1000))>0){
        if (FileRead(FileHandle2,Buffer2,Readed)!=Readed ||
            !CompareMem((void*)Buffer1,(void*)Buffer2,Readed) ){
                FileClose(FileHandle1);
                FileClose(FileHandle2);
                delete[] Buffer1;
                delete[] Buffer2;
                return false;
        }
    }
    FileClose(FileHandle1);
    FileClose(FileHandle2);
    delete[] Buffer1;
    delete[] Buffer2;
    return true;
}

